/*
 *   debugger.h
 *
 *   This file is part of Emu48
 *
 *   Copyright (C) 1999 Christoph Gieelink
 *
 */

// breakpoint type definitions
#define BP_EXEC   1							// code breakpoint
#define BP_READ   2							// read memory breakpoint
#define BP_WRITE  4							// write memory breakpoint
#define BP_ACCESS (BP_READ|BP_WRITE)		// read/write memory breakpoint

// debugger state definitions
#define DBG_RUN			0
#define DBG_STEPINTO	1
#define DBG_STEPOVER    2
#define DBG_STEPOUT     3

// debugger.c
#ifndef	UNDER_CE
extern BOOL    CheckBreakpoint(DWORD dwAddr, DWORD wRange, UINT nType);
#endif
extern VOID    NotifyDebugger(BOOL bType);
extern VOID    DisableDebugger(VOID);
extern LRESULT OnToolDebug(VOID);
extern VOID    LoadBreakpointList(HANDLE hFile);
extern VOID    SaveBreakpointList(HANDLE hFile);
